#include "complejo.h"



Complejo Construye(double r, double i) {

  Complejo comp;

  comp.real = r;

  comp.imag = i;

  return comp;

}



Complejo operator+(Complejo c1, Complejo c2) {

  Complejo comp;

  comp.real = c1.real + c2.real;

  comp.imag = c1.imag + c2.imag;

  return comp;

}



Complejo operator-(Complejo c1, Complejo c2) {

  Complejo comp;

  comp.real = c1.real - c2.real;

  comp.imag = c1.imag - c2.imag;

  return comp;

}



Complejo operator*(Complejo c1, Complejo c2) {

  Complejo comp;

  comp.real = c1.real * c2.real - c1.imag * c2.imag;

  comp.imag = c1.real * c2.imag + c1.imag * c2.real;

  return comp;

}



Complejo operator/(Complejo c1, Complejo c2) {

  Complejo comp;

  // Hacemos que comp sea el complementario de c2

  comp.real = c2.real;

  comp.imag = - c2.imag;

  // multiplicamos c1 por el complementario de c2 (comp)

  comp = c1 * comp;

  // slo queda dividir por la suma de los cuadrados

  // de las partes real e imaginaria de c2

  double divisor = c2.real * c2.real + c2.imag * c2.imag;

  comp.real = comp.real / divisor;

  comp.imag = comp.imag / divisor;

  return comp;

}



void mostrar(Complejo c) {

  cout << "(" << c.real << " + " << c.imag << "i)\n";

}



