// Clase Empleado - Archivo de implementacin "empleado.cpp"



#include <iostream>

using namespace std;



#include "empleado0.h"



Empleado::Empleado(long int dni, bool casado, int hijos,

  double sueldo, double tipo, double pago, double extras)

  : _dni(dni), _casado(casado), _hijos(hijos), _sueldoBase(sueldo),

    _tipo(tipo), _pagoHoraExtra(pago), _horasExtra(extras) { }



Empleado::Empleado(const Empleado& otro) {

  _dni = otro._dni;

  _casado = otro._casado;

  _hijos = otro._hijos;

  _sueldoBase = otro._sueldoBase;

  _tipo = otro._tipo;

  _pagoHoraExtra = otro._pagoHoraExtra;

  _horasExtra = otro._horasExtra;

}



Empleado& Empleado::operator=(const Empleado& otro) {

  _dni = otro._dni;

  _casado = otro._casado;

  _hijos = otro._hijos;

  _sueldoBase = otro._sueldoBase;

  _tipo = otro._tipo;

  _pagoHoraExtra = otro._pagoHoraExtra;

  _horasExtra = otro._horasExtra;

  return *this;

}



Empleado::~Empleado() { }



long int Empleado::dni() const { return _dni; }



bool Empleado::casado() const { return _casado; }



void Empleado::casado(bool c) { _casado = c; }



int Empleado::hijos() const { return _hijos; }



void Empleado::hijos(int h) { _hijos = h; }



double Empleado::sueldoBase() const { return _sueldoBase; }



void Empleado::sueldoBase(double sb) { _sueldoBase = sb; }



double Empleado::tipo() const { return _tipo; }



void Empleado::tipo(double t) { _tipo = t; }



double Empleado::pagoHoraExtra() const { return _pagoHoraExtra; }



void Empleado::pagoHoraExtra(double phe) { _pagoHoraExtra = phe; }



double Empleado::horasExtra() const { return _horasExtra; }



void Empleado::horasExtra(double he) { _horasExtra = he; }



double Empleado::complemento() const {

  return _pagoHoraExtra * _horasExtra;

}



double Empleado::sueldoBruto() const {

  return _sueldoBase + complemento();

}



double Empleado::retenciones() const {

// El tipo siempre es suficientemente alto, por lo que

// nunca se aplicar un tipo final negativo

  double tipoFinal = _tipo;

  if(_casado) tipoFinal -= 2;

  tipoFinal -= _hijos;

  return sueldoBruto() * tipoFinal / 100;

}



void Empleado::mostrar() const {

  cout << endl;

  cout << "D.N.I.: " << _dni << endl;

  cout << "Casado: " << (_casado ? "Si" : "No") << endl;

  cout << "Hijos: " << _hijos << endl;

  cout << "Sueldo base: " << _sueldoBase << endl;

  cout << "Porcentaje IRPF: " << _tipo << endl;

  cout << "Pago por hora extra: " << _pagoHoraExtra << endl;

  cout << "Horas extra realizadas: " << _horasExtra << endl;

}



void Empleado::mostrarTodo() const {

  mostrar(); // muestra la informacin bsica

  cout << "Complemento horas extra: " << complemento() << endl;

  double sueldo = sueldoBruto();

  cout << "Sueldo bruto: " << sueldo << endl;

  double ret = retenciones();

  cout << "Retenciones I.R.P.F.: " << ret << endl;

  sueldo -= ret;

  cout << "Sueldo neto: " << sueldo << endl;

}



void Empleado::leer()  {

  cout << "Por favor, introduzca los datos del empleado" << endl;

  cout << "D.N.I.: "; cin >> _dni;

  cout << "Casado? (s/n) ";

  char c; cin >> c;

  _casado = (c=='s') ? true : false;

  cout << "Hijos: "; cin >> _hijos;

  cout << "Sueldo base: "; cin >> _sueldoBase;

  cout << "Porcentaje IRPF: "; cin >> _tipo;

  cout << "Pago por hora extra: "; cin >> _pagoHoraExtra;

  cout << "Horas extra realizadas: "; cin >> _horasExtra;

}



