#include <iostream>
#include <string>
using namespace std;

#include "fechahora.h"
#include "efectivo.h"
#include "transferencia.h"
#include "nomina.h"
#include "recibo.h"
#include "cajero.h"
#include "cuenta.h"
#include "lista.h"

int main() {
  Lista<Cuenta,500> banco;
  Cuenta* ahorros = new Cuenta(Persona("223344G", 25, "Javier", "Vegas Vegas"),
                              Fecha(23, 11, 2002), 100);
  FechaHora fh(Fecha(29,11,2002),Hora(10,36,59));
  ahorros->nuevo(new Efectivo(125, fh));

  fh = fh + 90012; // Un tiempo despus
  ahorros->nuevo(new Transferencia(325.60, fh));

  fh = fh + 70235; // Un tiempo despus
  ahorros->nuevo(new Cajero(50, fh));

  fh = fh + 215014; // Un tiempo despus
  ahorros->nuevo(new Nomina(1025.73, fh));

  fh = fh + 100001; // Un tiempo despus
  ahorros->nuevo(new Recibo(120, fh));
  ahorros->mostrar();

  banco.insertar(ahorros);
  banco.mostrar();

  // Como las listas se encargan de eliminar (delete) todos los
  // objetos insertados en ellas, no hay que eliminar aqu nada.

  return 0;
}
