// Clase ConISBN - Implementacin "conisbn.cpp"

#include "conisbn.h"

// F.C.O.

ConISBN::ConISBN(string tit, string c, string p, Fecha f,
  Persona* a, string isbn, int ed, string edit)
  : Volumen(tit, c, p, f, a), _isbn(isbn), _edicion(ed), _editorial(edit) { }

ConISBN::ConISBN(const ConISBN& otro) : Volumen (otro) {
  _isbn = otro._isbn;
  _edicion = otro._edicion;
  _editorial = otro._editorial;
}

ConISBN& ConISBN::operator=(const ConISBN& otro) {
  Volumen::operator=(otro);
  _isbn = otro._isbn;
  _edicion = otro._edicion;
  _editorial = otro._editorial;
  return *this;
}

ConISBN::~ConISBN() { }

// Accedentes

string ConISBN::isbn() const { return _isbn; }

int ConISBN::edicion() const { return _edicion; }

string ConISBN::editorial() const { return _editorial; }

// Mutadores

void ConISBN::isbn(string i) { _isbn = i; }

void ConISBN::edicion(int e) { _edicion = e; }

void ConISBN::editorial(string e) { _editorial = e; }

// Otros mtodos

void ConISBN::leer() {
  Volumen::leer();
  cout << "ISBN: "; cin >> _isbn;
  cout << "Edicin: "; cin >> _edicion;
  cout << "Editorial: "; cin >> _editorial;
}

void ConISBN::mostrar() const {
  Volumen::mostrar();
  cout << _edicion << "a. edicin (" << _isbn << "), " << _editorial << ". ";
}



 