// Clase Lista (genrica) - Archivo nico "lista.h"

#ifndef lista_h
#define lista_h

#include <iostream>
using namespace std;

template<class X, int MAX = 100> class Lista {
public:
  Lista();
  Lista(const Lista&);
  Lista& operator=(const Lista&);
  ~Lista();
  bool llena() const;
  bool vacia() const;
  int cont() const;
  bool insertar(X*);
  bool recuperar(int, X*&) const; // la posicin, de 1 a cont()
  bool eliminar(int); // la posicin, de 1 a cont()
  void mostrar() const;
private:
  X* _array[MAX];
  int _cont;
};

template<class X, int MAX> Lista<X,MAX>::Lista() : _cont(0) {}

template<class X, int MAX>
Lista<X,MAX>::Lista(const Lista& otra) {
  _cont = otra._cont;
  for(int i = 0; i < _cont; i++)
    _array[i] = otra._array[i]->clon();
}

template<class X, int MAX>
Lista<X,MAX>& Lista<X,MAX>::operator=(const Lista& otra) {
  // Primero eliminamos los elementos de la lista
  for(int i = 0; i < _cont; i++) delete _array[i];
  _cont = otra._cont;
  for(int i = 0; i < _cont; i++)
    _array[i] = otra._array[i]->clon();
  return *this;
}

template<class X, int MAX>
Lista<X,MAX>::~Lista() {
  for(int i = 0; i < _cont; i++) delete _array[i];
}

template<class X, int MAX>
bool Lista<X,MAX>::llena() const { return _cont == MAX; }

template<class X, int MAX>
bool Lista<X,MAX>::vacia() const { return _cont == 0; }

template<class X, int MAX>
int Lista<X,MAX>::cont() const { return _cont; }

template<class X, int MAX>
bool Lista<X,MAX>::insertar(X* p) {
  if(_cont == MAX) return false;
  _array[_cont] = p;
  _cont++;
  return true;
}

template<class X, int MAX>
bool Lista<X,MAX>::recuperar(int pos, X*& p) const {
  if(pos < 1 || pos > _cont) return false;
  p = _array[pos-1];
  return true;
}

template<class X, int MAX>
bool Lista<X,MAX>::eliminar(int pos) {
  if(pos < 1 || pos > _cont) return false;
  delete _array[pos-1];
  for(int i = pos; i < _cont; i++)
    _array[i-1] = _array[i]; // Ocupamos el hueco dejado
  _cont--;
  return true;
}

template<class X, int MAX>
void Lista<X,MAX>::mostrar() const {
  for(int i = 0; i < _cont; i++) _array[i]->mostrar();
}

#endif
