// Clase Movimiento - Implementacin "movimiento.cpp"

#include "movimiento.h"

Movimiento::Movimiento(string concepto, double cantidad, FechaHora momento)
  : _concepto(concepto), _cantidad(cantidad), _momento(new FechaHora(momento)) { }

Movimiento::Movimiento(const Movimiento& otro) {
  _concepto = otro._concepto;
  _cantidad = otro._cantidad;
  _momento = new FechaHora(*otro._momento);
}

Movimiento& Movimiento::operator=(const Movimiento& otro) {
  _concepto = otro._concepto;
  _cantidad = otro._cantidad;
  *_momento = *otro._momento;
  return *this;
}

Movimiento::~Movimiento() { delete _momento; }

string Movimiento::concepto() const { return _concepto; }

double Movimiento::cantidad() const { return _cantidad; }

FechaHora Movimiento::momento() const { return *_momento; }

void Movimiento::concepto(string cad) { _concepto = cad; }

void Movimiento::cantidad(double num) { _cantidad = num; }

void Movimiento::momento(FechaHora fh) { *_momento = fh; }

void Movimiento::leer() {
  cout << endl;
  cout << "Cantidad: "; cin >> _cantidad;
  cout << "Fecha y hora:" << endl;
  _momento->leer();
}

void Movimiento::mostrar() const {
  cout << _momento->reducida() << "   " << _concepto
       << "   " << _cantidad << " Eur" << endl;
}

