// Clase Movimiento - Archivo de cabecera "movimiento.h"

#ifndef movimiento_h // Evitar inclusiones mltiples
#define movimiento_h

#include <iostream>
#include <string>
using namespace std;
#include "fechahora.h"

class Movimiento { // Clase abstracta
public:
  Movimiento(string = "", double = 0, FechaHora = FechaHora());
  // Datos: Concepto, cantidad y momento
  Movimiento(const Movimiento&);
  Movimiento& operator=(const Movimiento&);
  virtual ~Movimiento();
  string concepto() const;
  double cantidad() const;
  FechaHora momento() const;
  void concepto(string);
  void cantidad(double);
  void momento(FechaHora);
  void leer();
  void mostrar() const;
  virtual double apunte() const = 0; // Mtodo virtual puro
  virtual Movimiento* clon() const = 0; // Mtodo virtual puro
private:
  string _concepto;
  double _cantidad;
  FechaHora* _momento; // Atributo dinmico
};

#endif

