#include <iostream>
#include <vector>
using namespace std;

template<class T>
void mostrar(const vector<T> &v);

int main() {
  vector<int> vec;
  cout << "El tamao inicial de vec es: " << vec.size() << endl;

  vec.push_back(2);
  vec.push_back(3);
  vec.push_back(4);
  cout << "El tamao de vec ahora es: " << vec.size() << endl;

  cout << "Contenido del vector utilizando un iterador:" << endl;
  mostrar(vec);

  cout << "Contenido del vector al revs:" << endl;
  vector<int>::reverse_iterator iterinv; // Iterador inverso
  for(iterinv = vec.rbegin(); iterinv != vec.rend(); ++iterinv)
    cout << *iterinv << " ";
  cout << endl;

  cout << "El primer elemento de vec es: " << vec.front() << endl;
  cout << "El ltimo elemento de vec es: " << vec.back() << endl;

  vec[0] = 7; // Pone a 7 el primer elemento
  vec.at(2) = 10; // Pone a 10 el tercer elemento
  cout << "Contenido del vector:" << endl;
  mostrar(vec);

  vec.insert(vec.begin() + 1, 22); // Inserta 22 como segundo elemento
  cout << "Contenido del vector:" << endl;
  mostrar(vec);

  try {
    vec.at(100) = 777; // Fuera de intervalo
  }
  catch(out_of_range) {
    cout << "Intento de acceso a posicin inexistente" << endl;
  }

  vec.erase(vec.begin());
  cout << "Contenido del vector despus de eliminar el primero:" << endl;
  mostrar(vec);

  vec.erase(vec.begin(), vec.end());
  cout << "Ahora el vector " << (vec.empty() ? "est" : "no est") << " vaco" << endl;

  return 0;
}

template<class T>
void mostrar(const vector<T> &v) {
  vector<T>::const_iterator iter; // Iterador de lectura
  for(iter = v.begin(); iter != v.end(); iter++)
    cout << *iter << " ";
  cout << endl;
}

