// Clase Empleado - Archivo de cabecera "empleado.h"



#ifndef empleado_h // Evitar inclusiones mltiples

#define empleado_h



class Empleado {

public:

  Empleado(long int = 0, bool = false, int = 0, double = 0,

           double = 0, double = 0, double = 0);

  // Datos: DNI, casado?, hijos, sueldo base, tipo IRPF,

  // pago por hora extra, horas extra realizadas.

  Empleado(const Empleado&);

  Empleado& operator=(const Empleado&);

  ~Empleado();

  long int dni() const;

  bool casado() const;

  void casado(bool);

  int hijos() const;

  void hijos(int);

  double sueldoBase() const;

  void sueldoBase(double);

  double tipo() const;

  void tipo(double);

  double pagoHoraExtra() const;

  void pagoHoraExtra(double);

  double horasExtra() const;

  void horasExtra(double);

  double complemento() const;

  double sueldoBruto() const;

  double retenciones() const;

  void mostrar() const;

  void mostrarTodo() const;

private:

  long int _dni;

  bool _casado;

  int _hijos;

  double _sueldoBase;

  double _tipo; // porcentaje de IRPF para impuestos

  double _pagoHoraExtra;

  double _horasExtra;

};



#endif



 