// Clase Complejo - Implementacin "complejo.cpp"



#include "complejo.h"

#include <iostream>

using namespace std;



Complejo::Complejo(double r, double i) : _real(r), _imag(i) { }



Complejo::Complejo(const Complejo& otro) {

  _real = otro._real;

  _imag = otro._imag;

}



Complejo& Complejo::operator=(const Complejo& otro) {

  _real = otro._real;

  _imag = otro._imag;

  return *this;

}



Complejo::~Complejo() { }



Complejo Complejo::operator+(Complejo otro) const {

  Complejo comp;

  comp._real = _real + otro._real;

  comp._imag = _imag + otro._imag;

  return comp;

}



Complejo Complejo::operator-(Complejo otro) const {

  Complejo comp;

  comp._real = _real - otro._real;

  comp._imag = _imag - otro._imag;

  return comp;

}



Complejo Complejo::operator*(Complejo otro) const {

  Complejo comp;

  comp._real = _real * otro._real - _imag * otro._imag;

  comp._imag = _real * otro._imag + _imag * otro._real;

  return comp;

}



Complejo Complejo::operator/(Complejo otro) const {

  Complejo comp;

  // Hacemos que comp sea el complementario de otro

  comp._real = otro._real;

  comp._imag = - otro._imag;

  // multiplicamos el receptor por el complementario de otro (comp)

  comp = (*this) * comp;

  // slo queda dividir por la suma de los cuadrados

  // de las partes real e imaginaria de otro

  double divisor = otro._real * otro._real + otro._imag * otro._imag;

  comp._real = comp._real / divisor;

  comp._imag = comp._imag / divisor;

  return comp;

}



void Complejo::mostrar() const {

  cout << "(" << _real << " + " << _imag << "i)\n";

}



 