// Clase ComplejoFrac - Implementacin "complejofrac.cpp"



#include "complejofrac.h"

#include <iostream>

using namespace std;



ComplejoFrac::ComplejoFrac() { }



ComplejoFrac::ComplejoFrac(Fraccion r, Fraccion i) : _real(r), _imag(i) { }



ComplejoFrac::ComplejoFrac(const ComplejoFrac& otro) {

  _real = otro._real;

  _imag = otro._imag;

}



ComplejoFrac& ComplejoFrac::operator=(const ComplejoFrac& otro) {

  _real = otro._real;

  _imag = otro._imag;

  return *this;

}



ComplejoFrac::~ComplejoFrac() { }



Fraccion ComplejoFrac::real() const { return _real; }



Fraccion ComplejoFrac::imag() const { return _imag; }



void ComplejoFrac::real(Fraccion f) { _real = f; }



void ComplejoFrac::imag(Fraccion f) { _imag = f; }



ComplejoFrac ComplejoFrac::operator+(ComplejoFrac otro) const {

  ComplejoFrac comp;

  comp._real = _real + otro._real;

  comp._imag = _imag + otro._imag;

  return comp;

}



ComplejoFrac ComplejoFrac::operator-(ComplejoFrac otro) const {

  ComplejoFrac comp;

  comp._real = _real - otro._real;

  comp._imag = _imag - otro._imag;

  return comp;

}



ComplejoFrac ComplejoFrac::operator*(ComplejoFrac otro) const {

  ComplejoFrac comp;

  comp._real = _real * otro._real - _imag * otro._imag;

  comp._imag = _real * otro._imag + _imag * otro._real;

  return comp;

}



ComplejoFrac ComplejoFrac::operator/(ComplejoFrac otro) const {

  ComplejoFrac comp;

  // Hacemos que comp sea el complementario de otro

  comp._real = otro._real;

  comp._imag = - otro._imag;

  // multiplicamos el receptor por el complementario de otro (comp)

  comp = (*this) * comp;

  // slo queda dividir por la suma de los cuadrados

  // de las partes real e imaginaria de otro

  Fraccion divisor = otro._real * otro._real + otro._imag * otro._imag;

  comp._real = comp._real / divisor;

  comp._imag = comp._imag / divisor;

  return comp;

}



void ComplejoFrac::mostrar() const {

  cout << "(";

  _real.mostrar();

  cout << " + ";

  _imag.mostrar();

  cout << "i)\n";

}





 