// Clase Fraccion - Archivo de cabecera "fraccion.h"

#ifndef fraccion_h // Evitar inclusiones mltiples
#define fraccion_h

class Fraccion {
public:
  Fraccion(int = 0, int = 0); // Constructor (predeterminado)
  Fraccion(const Fraccion&); // Constructor de copia
  Fraccion& operator=(const Fraccion&); // Copia
  ~Fraccion(); // Destructor
  // Mutadores:
  void numerador(int);
  void denominador(int);
  // Accedentes:
  int numerador() const;
  int denominador() const;
  Fraccion operator+(Fraccion) const;
  Fraccion operator-(Fraccion) const;
  Fraccion operator*(Fraccion) const;
  Fraccion operator/(Fraccion) const;
  bool operator==(Fraccion) const;
  bool operator!=(Fraccion) const;
  bool operator<(Fraccion) const;
  bool operator<=(Fraccion) const;
  bool operator>(Fraccion) const;
  bool operator>=(Fraccion) const;
  Fraccion& operator++();
  Fraccion& operator--();
  Fraccion operator-();
  Fraccion& operator+=(Fraccion);
  Fraccion& operator-=(Fraccion);
  void mostrar() const;
private:
  int _numerador, _denominador;
  void simplifica(); // Mtodo privado
};

#endif

