#include <iostream>
using namespace std;

class Pila { // Pila de enteros
public:
  Pila() : _tope(0) {}
  Pila(const Pila&);
  Pila& operator=(const Pila&);
  ~Pila() {}
  bool pilaVacia() const;
  bool pilaLlena() const;
  void push(int);
  int pop();
private:
  enum { MAX = 10 };
  int _array[MAX];
  int _tope;
}; 

Pila::Pila(const Pila& otra)
{
  _tope = otra._tope;
  for(int i = 0; i < MAX; i++)
    _array[i] = otra._array[i];
}

Pila& Pila::operator=(const Pila& otra)
{
  _tope = otra._tope;
  for(int i = 0; i < MAX; i++) 
    _array[i] = otra._array[i];
  return *this;
}

bool Pila::pilaVacia() const { return _tope == 0; }

bool Pila::pilaLlena() const { return _tope == MAX; }

void Pila::push(int dato)
{
  if(_tope < MAX) {
    _array[_tope] = dato;
    _tope++;
  }
}

int Pila::pop()
{
  if(_tope == 0) {
    cout << "No hay elementos en la pila" << endl;
    return 0;
  }
  else {
    _tope--;
    return _array[_tope];
  }
}

int main()
{
  Pila unaPila;
  int i;

  do {
    cout << "Un entero (0 para terminar): ";
    cin >> i;
    if(i != 0) unaPila.push(i);
	} while(i != 0);

  while(!unaPila.pilaVacia())
    cout << unaPila.pop() << " ";
  cout << endl;
	
  return 0;
}
