// Clase Libro - Implementacin "libro.cpp"

#include "libro.h"

// F.C.O.

Libro::Libro() : _paginas(0), _edicion(1) { }
// Los dems atributos se inicializan automticamente
// (son objetos de otras clases - string, Persona o Fecha)

Libro::Libro(const Libro& otro) {
  _titulo = otro._titulo;
  _autor = otro._autor;
  _isbn = otro._isbn;
  _paginas = otro._paginas;
  _edicion = otro._edicion;
  _editorial = otro._editorial;
  _ciudad = otro._ciudad;
  _pais = otro._pais;
  _fecha = otro._fecha;
}

Libro& Libro::operator=(const Libro& otro) {
  _titulo = otro._titulo;
  _autor = otro._autor;
  _isbn = otro._isbn;
  _paginas = otro._paginas;
  _edicion = otro._edicion;
  _editorial = otro._editorial;
  _ciudad = otro._ciudad;
  _pais = otro._pais;
  _fecha = otro._fecha;
  return *this;
}

Libro::~Libro() { }

Libro::Libro(string tit, Persona per, string isbn, int pag, int edic,
             string edit, string c, string p, Fecha f) : _titulo(tit),
             _autor(per), _isbn(isbn), _paginas(pag), _edicion(edic),
             _editorial(edit), _ciudad(c), _pais(p), _fecha(f) { }

// Accedentes

string Libro::titulo() const { return _titulo; }

Persona Libro::autor() const { return _autor; }

string Libro::isbn() const { return _isbn; }

int Libro::paginas() const { return _paginas; }

int Libro::edicion() const { return _edicion; }

string Libro::editorial() const { return _editorial; }

string Libro::ciudad() const { return _ciudad; }

string Libro::pais() const { return _pais; }

Fecha Libro::fecha() const { return _fecha; }

// Mutadores

void Libro::titulo(string t) { _titulo = t; }

void Libro::autor(Persona a) { _autor = a; }

void Libro::isbn(string i) { _isbn = i; }

void Libro::paginas(int p) { _paginas = p; }

void Libro::edicion(int e) { _edicion = e; }

void Libro::editorial(string e) { _editorial = e; }

void Libro::ciudad(string c) { _ciudad = c; }

void Libro::pais(string p) { _pais = p; }

void Libro::fecha(Fecha f) { _fecha = f; }

// Otros mtodos

void Libro::leer() {
// El autor y la fecha se habrn ledo en otro sitio
  cout << "Titulo: "; getline(cin, _titulo);
  cout << "I.S.B.N.: "; getline(cin, _isbn);
  cout << "Numero de paginas: "; cin >> _paginas;
  cout << "Numero de edicion: "; cin >> _edicion;
  cin.ignore();
  cout << "Editorial: "; getline(cin, _editorial);
  cout << "Lugar de edicion:" << endl;
  cout << "  Ciudad: "; getline(cin, _ciudad);
  cout << "  Pais: "; getline(cin, _pais);
}

void Libro::mostrar() const {
  cout << endl;
  cout << "Titulo: " << _titulo << endl;
  cout << _edicion << "a. edicion" << endl;
  cout << "Autor: " << _autor.apellidos() << ", " << _autor.nombre() << endl;
  cout << "ISBN: " << _isbn << endl;
  cout << _editorial << ", " << _ciudad << " (" << _pais
       << "), " << _fecha.completa() << endl;
  cout << _paginas << " paginas" << endl;
}

