// Clase Libro - Archivo de cabecera "libro.h"

#ifndef libro_h // Evitar inclusiones mltiples
#define libro_h

#include <iostream>
#include <string>
using namespace std;
#include "persona.h"
#include "fecha.h"

class Libro {
public:
  // F.C.O.
  Libro();
  Libro(const Libro&);
  Libro& operator=(const Libro&);
  ~Libro();
  // Otro constructor
  Libro(string, Persona, string, int, int, string, string, string, Fecha);
  // Datos: ttulo, autor, ISBN, pginas, edicin, editorial,
  //        ciudad, pas, fecha de edicin.
  // Accedentes
  string titulo() const;
  Persona autor() const;
  string isbn() const;
  int paginas() const;
  int edicion() const;
  string editorial() const;
  string ciudad() const;
  string pais() const;
  Fecha fecha() const;
  // Mutadores
  void titulo(string);
  void autor(Persona);
  void isbn(string);
  void paginas(int);
  void edicion(int);
  void editorial(string);
  void ciudad(string);
  void pais(string);
  void fecha(Fecha);
  // Otros mtodos
  void leer();
  void mostrar() const;
private:
  string _titulo;
  Persona _autor;
  string _isbn;
  int _paginas;
  int _edicion;
  string _editorial;
  string _ciudad, _pais;
  Fecha _fecha;
};

#endif

 