#include <iostream>
#include <string>
using namespace std;

#include "persona.h" // Inclusin de la clase Persona

class Lista {
public:
  Lista() : _cont(0) {}
  Lista(const Lista&);
  Lista& operator=(const Lista&);
  ~Lista() {}
  bool llena() const;
  bool vacia() const;
  bool insertar(Persona);
  bool recuperar(int, Persona&);
  void mostrar() const;
private:
  enum { MAX = 100 };
  Persona _array[MAX];
  int _cont;
}; // Fin de la definicin de la clase Lista

Lista::Lista(const Lista& otra) {
  _cont = otra._cont;
  for(int i = 0; i < _cont; i++)
    _array[i] = otra._array[i];
}

Lista& Lista::operator=(const Lista& otra) {
  _cont = otra._cont;
  for(int i = 0; i < _cont; i++)
    _array[i] = otra._array[i];
  return *this;
}

bool Lista::llena() const { return _cont == MAX; }

bool Lista::vacia() const { return _cont == 0; }

bool Lista::insertar(Persona p) {
// Devuelve true si se inserta; false si lista llena
  if(_cont == MAX) return false;
  _array[_cont] = p;
  _cont++;
  return true;
}

bool Lista::recuperar(int pos, Persona& p) {
// true si tiene xito; false si posicin no vlida
  if(pos < 1 || pos > _cont) return false;
  p = _array[pos-1];
  return true;
}

void Lista::mostrar() const {
  cout << "Elementos de la lista:" << endl;
  for(int i = 0; i < _cont; i++)
    _array[i].mostrar();
}

// Prueba de la lista de personas
int main() {
  Persona persona;
  Lista miLista;
  int op, pos;
	  do {
    cout << "1 - Insertar" << endl;
    cout << "2 - Obtener" << endl;
    cout << "3 - Listar" << endl;
    cout << "0 - Salir" << endl;
    cout << "Opcion: "; cin >> op;
    switch(op) {
      case 1:
        if(miLista.llena())
          cout << "La lista ya est llena" << endl;
       else {
          persona.leer();
          miLista.insertar(persona);
        }
        break;
      case 2:
        cout << "Posicin: ";
        cin >> pos;
        if(miLista.recuperar(pos,persona))
          persona.mostrar();
        else
          cout << "No hay elemento en esa posicin"
               << endl;
        break;
      case 3:
        miLista.mostrar();
        break;
      } // fin del switch
  } while(op != 0);

  return 0;
}
 
