// Nombre y dos apellidos

// Clase Cuenta - Implementacin "cuenta.h"

#include "cuenta.h"

Cuenta::Cuenta(Persona cliente, Fecha fecha, Hora hora, double saldo)
  : _cliente(cliente), _fecha(fecha), _hora(hora), _saldo(saldo) { }

Cuenta::Cuenta(const Cuenta& otra) {
  _cliente = otra._cliente;
  _fecha = otra._fecha;
  _hora = otra._hora;
  _saldo = otra._saldo;
}

Cuenta& Cuenta::operator=(const Cuenta& otra) {
  _cliente = otra._cliente;
  _fecha = otra._fecha;
  _hora = otra._hora;
  _saldo = otra._saldo;
  return *this;
}

Cuenta::~Cuenta() { }

Persona Cuenta::cliente() const { return _cliente; }

void Cuenta::cliente(Persona p) { _cliente = p; }

Fecha Cuenta::fecha() const { return _fecha; }

void Cuenta::fecha(Fecha f) { _fecha = f; }

Hora Cuenta::hora() const { return _hora; }

void Cuenta::hora(Hora h) { _hora = h; }

double Cuenta::saldo() const { return _saldo; }

void Cuenta::saldo(double s) { _saldo = s; }

Cuenta Cuenta::operator+(double cantidad) const {
  Cuenta tmp = *this;
  tmp._saldo += cantidad;
  return tmp;
}

Cuenta Cuenta::operator-(double cantidad) const {
  Cuenta tmp = *this;
  tmp._saldo -= cantidad;
  return tmp;
}

Cuenta& Cuenta::operator+=(double cantidad) {
  _saldo += cantidad;
  return *this;
}

Cuenta& Cuenta::operator-=(double cantidad) {
  _saldo -= cantidad;
  return *this;
}

void Cuenta::mostrar() const {
  cout << endl;
  cout << "Cliente: " << _cliente.nombreCompleto() << " ("
       << _cliente.nif() << "), " << _cliente.edad() << " aos" << endl;
  cout << "Cuenta abierta el " << _fecha.completa()
       << " a las " << _hora.hora() << endl;
  cout << "Saldo actual: " << _saldo << " eur" << endl;
}

