// Nombre y dos apellidos

// Clase Deuda - Implementacin "deuda.h"

#include "deuda.h"

Deuda::Deuda(Persona deudor, Fecha fecha, double interes, double deuda)
  : _deudor(deudor), _fecha(fecha), _interes(interes), _deuda(deuda) { }

Deuda::Deuda(const Deuda& otra) {
  _deudor = otra._deudor;
  _fecha = otra._fecha;
  _interes = otra._interes;
  _deuda = otra._deuda;
}

Deuda& Deuda::operator=(const Deuda& otra) {
  _deudor = otra._deudor;
  _fecha = otra._fecha;
  _interes = otra._interes;
  _deuda = otra._deuda;
  return *this;
}

Deuda::~Deuda() { }

Persona Deuda::deudor() const { return _deudor; }

void Deuda::deudor(Persona p) { _deudor = p; }

Fecha Deuda::fecha() const { return _fecha; }

void Deuda::fecha(Fecha f) { _fecha = f; }

double Deuda::interes() const { return _interes; }

void Deuda::interes(double i) { _interes = i; }

double Deuda::deuda() const { return _deuda; }

void Deuda::deuda(double d) { _deuda = d; }

Deuda& Deuda::operator++() {
  _interes += 0.001;
  return *this;
}

Deuda& Deuda::operator--() {
  _interes -= 0.001;
  return *this;
}

void Deuda::pago(Fecha fp, double cantidad) {
  long int dias = fp - _fecha;
  double intereses = _deuda * _interes / 100 * dias;
  _deuda += intereses - cantidad;
  _fecha = fp;
}

void Deuda::mostrar() const {
  cout << endl;
  cout << "Deudor: " << _deudor.nombreCompleto() << " ("
       << _deudor.nif() << "), " << _deudor.edad() << " anos" << endl;
  cout << "Deuda pendiente: " << _deuda
       << " eur (Interes: " << _interes << "%)" << endl;
  cout << "Desde el " << _fecha.completa() << endl;
}

