// Nombre y dos apellidos

// Clase Evento - Implementacin "evento.h"

#include "evento.h"

Evento::Evento(Persona responsable, Fecha fi, Hora hi,
               Fecha ff, Hora hf, int nivel)
  : _responsable(responsable), _fechaInicio(fi), _horaInicio(hi),
    _fechaFin(ff), _horaFin(hf), _nivel(nivel) { }

Evento::Evento(const Evento& otro) {
  _responsable = otro._responsable;
  _fechaInicio = otro._fechaInicio;
  _horaInicio = otro._horaInicio;
  _fechaFin = otro._fechaFin;
  _horaFin = otro._horaFin;
  _nivel = otro._nivel;
}

Evento& Evento::operator=(const Evento& otro) {
  _responsable = otro._responsable;
  _fechaInicio = otro._fechaInicio;
  _horaInicio = otro._horaInicio;
  _fechaFin = otro._fechaFin;
  _horaFin = otro._horaFin;
  _nivel = otro._nivel;
  return *this;
}

Evento::~Evento() { }

Persona Evento::responsable() const { return _responsable; }

void Evento::responsable(Persona p) { _responsable = p; }

Fecha Evento::fechaInicio() const { return _fechaInicio; }

void Evento::fechaInicio(Fecha f) { _fechaInicio = f; }

Hora Evento::horaInicio() const { return _horaInicio; }

void Evento::horaInicio(Hora h) { _horaInicio = h; }

Fecha Evento::fechaFin() const { return _fechaFin; }

void Evento::fechaFin(Fecha f) { _fechaFin = f; }

Hora Evento::horaFin() const { return _horaFin; }

void Evento::horaFin(Hora h) { _horaFin = h; }

int Evento::nivel() const { return _nivel; }

void Evento::nivel(int n) { _nivel = n; }

Evento& Evento::operator++() {
  _nivel++;
  return *this;
}

Evento& Evento::operator--() {
  _nivel--;
  return *this;
}

long int Evento::duracion() const {
  const long int SPD = 86400;
  long int seg = (_fechaFin - _fechaInicio) * SPD + (_horaFin - _horaInicio);
  return seg / 60;
}

void Evento::mostrar() const {
  cout << endl;
  cout << "Responsable: " << _responsable.nombreCompleto() << endl;
  cout << "Evento iniciado el " << _fechaInicio.completa()
       << " a las " << _horaInicio.hora() << endl;
  cout << "Evento terminado el " << _fechaFin.completa()
       << " a las " << _horaFin.hora() << endl;
  cout << "Duracin: " << duracion() << " min." << endl;
  cout << "Nivel de servicio: " << _nivel << endl;
}

