// Nombre y dos apellidos

// Clase Evento - Archivo de cabecera "evento.h"

#ifndef evento_h // Evitar inclusiones mltiples
#define evento_h

#include <iostream>
#include <string>
using namespace std;
#include "persona.h"
#include "fecha.h"
#include "hora.h"

class Evento {
public:
  Evento(Persona = Persona(), Fecha = Fecha(), Hora = Hora(),
         Fecha = Fecha(), Hora = Hora(), int = 0);
  Evento(const Evento&);
  Evento& operator=(const Evento&);
  ~Evento();
  Persona responsable() const;
  void responsable(Persona);
  Fecha fechaInicio() const;
  void fechaInicio(Fecha);
  Hora horaInicio() const;
  void horaInicio(Hora);
  Fecha fechaFin() const;
  void fechaFin(Fecha);
  Hora horaFin() const;
  void horaFin(Hora);
  int nivel() const;
  void nivel(int);
  Evento& operator++();
  Evento& operator--();
  long int duracion() const;
  void mostrar() const;
private:
  Persona _responsable;
  Fecha _fechaInicio, _fechaFin;
  Hora _horaInicio, _horaFin;
  int _nivel;
};

#endif
 