// Nombre y dos apellidos

// Clase Mueble - Implementacin "mueble.h"

#include "mueble.h"

float Mueble::_porM3 = 1233;
float Mueble::_porDia = 150;

Mueble::Mueble(string desc, Persona carpintero, double madera,
               Fecha inicio, Fecha fin)
  : _descripcion(desc), _carpintero(carpintero), _madera(madera),
    _inicio(inicio), _fin(fin) { }

Mueble::Mueble(const Mueble& otro) {
  _descripcion = otro._descripcion;
  _carpintero = otro._carpintero;
  _madera = otro._madera;
  _inicio = otro._inicio;
  _fin = otro._fin;
}

Mueble& Mueble::operator=(const Mueble& otro) {
  _descripcion = otro._descripcion;
  _carpintero = otro._carpintero;
  _madera = otro._madera;
  _inicio = otro._inicio;
  _fin = otro._fin;
  return *this;
}

Mueble::~Mueble() { }

string Mueble::descripcion() const { return _descripcion; }

void Mueble::descripcion(string m) { _descripcion = m; }

Persona Mueble::carpintero() const { return _carpintero; }

void Mueble::carpintero(Persona p) { _carpintero = p; }

double Mueble::madera() const { return _madera; }

void Mueble::madera(double p) { _madera = p; }

Fecha Mueble::inicio() const { return _inicio; }

void Mueble::inicio(Fecha f) { _inicio = f; }

Fecha Mueble::fin() const { return _fin; }

void Mueble::fin(Fecha f) { _fin = f; }

double Mueble::total() const {
  const float IVA = 1.16;
  long int dias = _fin - _inicio;
  return (_madera * _porM3 + dias * _porDia) * IVA;
}

void Mueble::mostrar() const {
  cout << endl;
  cout << "Mueble: " << _descripcion << endl;
  cout << "Carpintero: " << _carpintero.nombreCompleto() << endl;
  cout << "Da de inicio: " << _inicio.reducida() << endl;
  cout << "Da de final: " << _fin.reducida() << endl;
  cout << "Importe de la madera: " << _madera * _porM3 << " eur" << endl;
  cout << "Importe de la mano de obra: " << (_fin - _inicio) * _porDia << " eur" << endl;
  cout << "Total de la fabricacin: " << total() << " eur (IVA inc.)" << endl;
}

