// Clase Pedido - Implementacin "pedido.h"

#include "pedido.h"

Pedido::Pedido(string codigo, string desc, Persona cliente,
           Fecha fecha, Hora hora, int prioridad)
  : _codigo(codigo), _descripcion(desc), _cliente(cliente),
    _fecha(fecha), _hora(hora), _prioridad(prioridad) { }

Pedido::Pedido(const Pedido& otro) {
  _codigo = otro._codigo;
  _descripcion = otro._descripcion;
  _cliente = otro._cliente;
  _fecha = otro._fecha;
  _hora = otro._hora;
  _prioridad = otro._prioridad;
}

Pedido& Pedido::operator=(const Pedido& otro) {
  _codigo = otro._codigo;
  _descripcion = otro._descripcion;
  _cliente = otro._cliente;
  _fecha = otro._fecha;
  _hora = otro._hora;
  _prioridad = otro._prioridad;
  return *this;
}

Pedido::~Pedido() { }

string Pedido::codigo() const { return _codigo; }

void Pedido::codigo(string s) { _codigo = s; }

string Pedido::descripcion() const { return _descripcion; }

void Pedido::descripcion(string s) { _descripcion = s; }

Persona Pedido::cliente() const { return _cliente; }

void Pedido::cliente(Persona p) { _cliente = p; }

Fecha Pedido::fecha() const { return _fecha; }

void Pedido::fecha(Fecha f) { _fecha = f; }

Hora Pedido::hora() const { return _hora; }

void Pedido::hora(Hora h) { _hora = h; }

int Pedido::prioridad() const { return _prioridad; }

void Pedido::prioridad(int i) { _prioridad = i; }

Pedido& Pedido::operator++() {
  _prioridad++;
  return *this;
}

Pedido& Pedido::operator--() {
  _prioridad--;
  return *this;
}

void Pedido::mostrar() const {
  cout << endl;
  cout << "Codigo: " << _codigo << "   Prioridad: " << _prioridad << endl;
  cout << "Descripcion: " << _descripcion << endl;
  cout << "Cliente: " << _cliente.nombreCompleto() << endl;
  cout << _fecha.reducida() << " " << _hora.hora() << endl;
}

