// Clase Pedido - Archivo de cabecera "pedido.h"

#ifndef pedido_h // Evitar inclusiones mltiples
#define pedido_h

#include <iostream>
#include <string>
using namespace std;
#include "persona.h"
#include "fecha.h"
#include "hora.h"

class Pedido {
public:
  Pedido(string = "", string = "", Persona = Persona(),
           Fecha = Fecha(), Hora = Hora(), int = 0);
  Pedido(const Pedido&);
  Pedido& operator=(const Pedido&);
  ~Pedido();
  string codigo() const;
  void codigo(string);
  string descripcion() const;
  void descripcion(string);
  Persona cliente() const;
  void cliente(Persona);
  Fecha fecha() const;
  void fecha(Fecha);
  Hora hora() const;
  void hora(Hora);
  int prioridad() const;
  void prioridad(int);
  Pedido& operator++();
  Pedido& operator--();
  void mostrar() const;
private:
  string _codigo, _descripcion;
  Persona _cliente;
  Fecha _fecha;
  Hora _hora;
  int _prioridad;
};

#endif
 