// Nombre y dos apellidos

// Clase Vehiculo - Implementacin "vehiculo.h"

#include "vehiculo.h"

float Vehiculo::_porMin = 0.375;

Vehiculo::Vehiculo(string modelo, Persona propietario, double piezas,
                   Fecha fecha, Hora inicio, Hora fin)
  : _modelo(modelo), _propietario(propietario), _piezas(piezas),
    _fecha(fecha), _inicio(inicio), _fin(fin) { }
    
Vehiculo::Vehiculo(const Vehiculo& otro) {
  _modelo = otro._modelo;
  _propietario = otro._propietario;
  _piezas = otro._piezas;
  _fecha = otro._fecha;
  _inicio = otro._inicio;
  _fin = otro._fin;
}

Vehiculo& Vehiculo::operator=(const Vehiculo& otro) {
  _modelo = otro._modelo;
  _propietario = otro._propietario;
  _piezas = otro._piezas;
  _fecha = otro._fecha;
  _inicio = otro._inicio;
  _fin = otro._fin;
  return *this;
}

Vehiculo::~Vehiculo() { }

string Vehiculo::modelo() const { return _modelo; }

void Vehiculo::modelo(string m) { _modelo = m; }

Persona Vehiculo::propietario() const { return _propietario; }

void Vehiculo::propietario(Persona p) { _propietario = p; }

double Vehiculo::piezas() const { return _piezas; }

void Vehiculo::piezas(double p) { _piezas = p; }

Fecha Vehiculo::fecha() const { return _fecha; }

void Vehiculo::fecha(Fecha f) { _fecha = f; }

Hora Vehiculo::inicio() const { return _inicio; }

void Vehiculo::inicio(Hora h) { _inicio = h; }

Hora Vehiculo::fin() const { return _fin; }

void Vehiculo::fin(Hora h) { _fin = h; }

double Vehiculo::total() const {
  const float IVA = 1.16;
  long int minutos = (_fin - _inicio) / 60;
  return (_piezas + minutos * _porMin) * IVA;
}

void Vehiculo::mostrar() const {
  cout << endl;
  cout << _fecha.completa() << endl;
  cout << "Vehiculo: " << _modelo << endl;
  cout << "Propietario: " << _propietario.nombreCompleto() << endl;
  cout << "Hora de inicio: " << _inicio.hora() << endl;
  cout << "Hora de final: " << _fin.hora() << endl;
  cout << "Importe de las piezas: " << _piezas << " eur" << endl;
  cout << "Total de la reparacion: " << total() << " eur (IVA inc.)" << endl;
}

