// Clase Vehiculo - Archivo de cabecera "vehiculo.h"

#ifndef vehiculo_h // Evitar inclusiones mltiples
#define vehiculo_h

#include <iostream>
#include <string>
using namespace std;
#include "persona.h"
#include "fecha.h"
#include "hora.h"

class Vehiculo {
public:
  Vehiculo(string = "", Persona = Persona(), double = 0,
           Fecha = Fecha(), Hora = Hora(), Hora = Hora());
    // Datos: modelo, propietario, coste de las piezas, fecha,
    //        hora de inicio y hora de fin
  Vehiculo(const Vehiculo&);
  Vehiculo& operator=(const Vehiculo&);
  ~Vehiculo();
  string modelo() const;
  void modelo(string);
  Persona propietario() const;
  void propietario(Persona);
  double piezas() const;
  void piezas(double);
  Fecha fecha() const;
  void fecha(Fecha);
  Hora inicio() const;
  void inicio(Hora);
  Hora fin() const;
  void fin(Hora);
  double total() const;
  void mostrar() const;
private:
  static float _porMin; // euros por minuto - atributo de clase
  string _modelo;
  Persona _propietario;
  double _piezas;
  Fecha _fecha;
  Hora _inicio, _fin;
};

#endif
 