// Clase FechaHora con herencia - Archivo de cabecera "fechahora.h"

#ifndef fechahora_h // Evitar inclusiones mltiples
#define fechahora_h

#include "fecha.h"
#include "hora.h"

class FechaHora : public Fecha, public Hora {
public:
	FechaHora(); // Constructor predeterminado
  FechaHora(const FechaHora&); // Constructor de copia
  FechaHora& operator=(const FechaHora&); // Op.asignacin
  ~FechaHora(); // Destructor

  // Otros constructores
	FechaHora(Fecha);
  FechaHora(Hora);
	FechaHora(Fecha, Hora);

  // Fechas y horas:
  Fecha fecha() const;
  Hora hora() const;
  void fecha(Fecha);
  void hora(Hora);

  // Operadores aritmticos:
  long int operator-(FechaHora) const;
  // Segundos entre la FechaHora y la proporcionada

  // long int operator-(Hora) const; se hereda de Hora
  // long int operator-(Fecha) const; se hereda de Fecha

  FechaHora operator+(long int) const; // + segundos
  FechaHora operator-(long int) const; // - segundos
  FechaHora& operator++(); // Un segundo ms
  FechaHora& operator--(); // Un segundo menos

  // Operadores relacionales:
	bool operator==(FechaHora) const;
	bool operator!=(FechaHora) const;
	bool operator<(FechaHora) const;
	bool operator<=(FechaHora) const;
	bool operator>(FechaHora) const;
	bool operator>=(FechaHora) const;

  // Otros mtodos:
  long int aDias(long int); // Segundos a das
  long int aSegundos(long int); // Das a segundos

  // string diaSemana() const; se hereda de Fecha

  string completa() const;
  // Cadena con la fecha completa seguida de la hora
  string reducida() const;
  // Cadena con la fecha reducida seguida de la hora
  void leer();

private:
	static long SPD; // Segundos por da
};

#endif
 