// Clase Hora - Archivo de cabecera "hora.h"

#ifndef hora_h // Evitar inclusiones mltiples
#define hora_h

#include <iostream>
#include <string>
using namespace std;

class Hora {
public:
	Hora(int = 0, int = 0, int = 0); // Constructor (horas, minutos, segundos)
  Hora(const Hora&);
  Hora& operator=(const Hora&);
  ~Hora();
	Hora(long int); // Otro constructor
    // Construye la hora pasados esos segundos desde la medianoche

  void horas(int);
  void minutos(int);   // Mutadores
  void segundos(int);

  int horas() const;
  int minutos() const; // Accedentes
  int segundos() const;

  long int operator-(Hora) const;
  // Segundos transcurridos entre la hora y la proporcionada
  Hora operator+(long int) const; // Incremento de la hora en segundos
  Hora operator-(long int) const; // Decremento de la hora en segundos
  Hora& operator+=(long int); // Abreviatura para la suma
  Hora& operator-=(long int); // Abreviatura para la resta
  Hora& operator++(); // Un segundo ms
  Hora& operator++(int); // (versin postfija)
  Hora& operator--(); // Un segundo menos
  Hora& operator--(int); // (versin postfija)

  bool operator==(Hora) const;
  bool operator!=(Hora) const;
  bool operator<(Hora) const;    // Operadores relacionales
  bool operator<=(Hora) const;
  bool operator>(Hora) const;
  bool operator>=(Hora) const;

  string hora() const; // Devuelve la hora en una cadena
  void leer();

private:
  int _horas, _minutos, _segundos;  // atributos
  void valida();
  // Comprueba que la hora est dentro del intervalo vlido.
  // Si no es as, corrige los datos incorrectos.
  void deSegundos(long int);
  // Pone la hora para esos segundos transcurridos desde la medianoche
  long int aSegundos() const;
  // Nmero de segundos transcurridos desde la medianoche.
};

#endif

