// Clase Persona - Archivo de cabecera "persona.h"

#ifndef persona_h // Evitar inclusiones mltiples
#define persona_h

#include <iostream>
#include <string>
using namespace std;

class Persona {
public:
  Persona(string = "", int = 0, string = "", string = "");
  // Constructor. Datos: NIF, edad, nombre y apellidos
  Persona(const Persona&); // Constructor de copia
  Persona& operator=(const Persona&); // Copia (asignacin)
  ~Persona(); // Destructor
  // Mutadores:
  void nif(string);
  void edad(int);
  void nombre(string);
  void apellidos(string);
  // Accedentes:
  string nif() const;
  int edad() const;
  string nombre() const;
  string apellidos() const;
  // Visualizador:
  void mostrar() const;
  // Resto de mtodos:
  string nombreCompleto() const; // Nombre y apellidos
  void felizCumple(); // El da del cumpleaos
  void leer(); // Lectura de los datos de la persona
private:
  // Atributos:
  string _nif;
  int _edad;
  string _nombre, _apellidos;
};

#endif

 