// Clase Articulo - Implementacin "articulo.cpp"

#include "articulo.h"
#include <iostream>
#include <string>
using namespace std;

// F.C.O.

Articulo::Articulo(string tit, string c, string p, Fecha f,
  Persona a, string s, int ini, int fin)
  : Volumen(tit, c, p, f, a), _serie(s), _inicial(ini), _final(fin) { }

Articulo::Articulo(const Articulo& otro) : Volumen (otro) {
  _serie = otro._serie;
  _inicial = otro._inicial;
  _final = otro._final;
}

Articulo& Articulo::operator=(const Articulo& otro) {
  Volumen::operator=(otro);
  _serie = otro._serie;
  _inicial = otro._inicial;
  _final = otro._final;
  return *this;
}

Articulo::~Articulo() { }

// Accedentes

string Articulo::serie() const { return _serie; }

int Articulo::inicial() const { return _inicial; }

int Articulo::final() const { return _final; }

// Mutadores

void Articulo::serie(string s) { _serie = s; }

void Articulo::inicial(int n) { _inicial = n; }

void Articulo::final(int n) { _final = n; }

// Otros mtodos

void Articulo::leer() {
  Volumen::leer();
  cout << "Ttulo de la revista o las actas: "; cin >> _serie;
  cout << "Pgina inicial: "; cin >> _inicial;
  cout << "Pgina final: "; cin >> _final;
}

void Articulo::mostrar() const {
  Volumen::mostrar();
  cout << "Revista o actas: " << _serie
       << " (" << _inicial << "-" << _final << ")" << endl;
}




 