// Clase Cuenta - Implementacin "cuenta.h"

#include "cuenta.h"

Cuenta::Cuenta(Persona cliente, Fecha fecha, double saldo)
  : _saldo(saldo) {
  _cliente = new Persona(cliente);
  _fecha = new Fecha(fecha);
  _movs = new Lista();
}

Cuenta::~Cuenta() {
  delete _cliente;
  delete _fecha;
  delete _movs;
}

Persona Cuenta::cliente() const { return *_cliente; }

void Cuenta::cliente(Persona p) { *_cliente = p; }

Fecha Cuenta::fecha() const { return *_fecha; }

void Cuenta::fecha(Fecha f) { *_fecha = f; }

double Cuenta::saldo() const { return _saldo; }

void Cuenta::saldo(double s) { _saldo = s; }

void Cuenta::nuevo(Movimiento* m) {
  _movs->insertar(m);
  // No sabemos todava cmo actualizar el saldo
}

void Cuenta::mostrar() const {
  cout << endl;
  cout << "Cliente: " << _cliente->nombreCompleto() << " ("
       << _cliente->nif() << "), " << _cliente->edad() << " aos" << endl;
  cout << "Cuenta abierta el " << _fecha->completa() << endl;
  cout << "Saldo inicial: " << _saldo << " eur" << endl;
}

void Cuenta::extracto() const {
  mostrar();
  _movs->mostrar();
}
