// Clase Lista (de publicaciones) - Implementacin "listabib.cpp"

#include <iostream>
#include <string>
using namespace std;
#include "listabib.h"

Lista::Lista() : _cont(0) {}

Lista::~Lista() {
  for(int i = 0; i < _cont; i++) delete _array[i];
}

bool Lista::llena() const { return _cont == MAX; }

bool Lista::vacia() const { return _cont == 0; }

int Lista::cont() const { return _cont; }

bool Lista::insertar(Publicacion* p) {
  if(_cont == MAX) return false;
  _array[_cont] = p;
  _cont++;
  return true;
}

bool Lista::recuperar(int pos, Publicacion*& p) const {
  if(pos < 1 || pos > _cont) return false;
  p = _array[pos-1];
  return true;
}

bool Lista::eliminar(int pos) {
  if(pos < 1 || pos > _cont) return false;
  delete _array[pos-1];
  for(int i = pos; i < _cont; i++)
    _array[i-1] = _array[i]; // Ocupamos el hueco dejado
  _cont--;
  return true;
}

void Lista::mostrar() const {
  cout << "Elementos de la lista:" << endl;
  for(int i = 0; i < _cont; i++)
    _array[i]->mostrar();
}
