// Clase Volumen - Implementacin "volumen.cpp"
// _autor como atributo dinmico

#include "volumen.h"

// F.C.O.

Volumen::Volumen(string tit, string c, string p, Fecha f, Persona a)
  : Publicacion(tit, c, p, f) { _autor = new Persona(); *_autor = a; }
  // Se crea el atributo dinmico

Volumen::Volumen(const Volumen& otro) : Publicacion (otro) {
  _autor = new Persona(); // Se crea el atributo dinmico
  *_autor = *otro._autor;
}

Volumen& Volumen::operator=(const Volumen& otro) {
  Publicacion::operator=(otro);
  *_autor = *otro._autor; // Se copia el atributo dinmico
  return *this;
}

Volumen::~Volumen() { delete _autor; } // Se elimina el atributo dinmico

// Accedente

Persona Volumen::autor() const { return *_autor; }

// Mutador

void Volumen::autor(Persona p) { *_autor = p; }

// Otros mtodos

void Volumen::leer() {
  Publicacion::leer();
  cout << "Datos del autor:" << endl;
  _autor->leer(); // El atributo dinmico siempre existe
}

void Volumen::mostrar() const {
  Publicacion::mostrar();
  cout << "Autor: " << _autor->nombreCompleto() << endl;
  // El atributo dinmico siempre existe
}


 