// Clase Cuenta - Implementacin "cuenta.h"

#include "cuenta.h"

Cuenta::Cuenta(Persona cliente, Fecha fecha, double saldo)
  : _saldo(saldo) {
  _cliente = new Persona(cliente);
  _fecha = new Fecha(fecha);
  _movs = new Lista();
}

Cuenta::Cuenta(const Cuenta& otra) {
  _cliente = new Persona(*otra._cliente);
  _fecha = new Fecha(*otra._fecha);
  _saldo = otra._saldo;
  _movs = new Lista(*otra._movs);
}

Cuenta& Cuenta::operator=(const Cuenta& otra) {
  *_cliente = *otra._cliente;
  *_fecha = *otra._fecha;
  _saldo = otra._saldo;
  *_movs = *otra._movs;
  return *this;
}

Cuenta::~Cuenta() {
  delete _cliente;
  delete _fecha;
  delete _movs;
}

Persona Cuenta::cliente() const { return *_cliente; }

void Cuenta::cliente(Persona p) { *_cliente = p; }

Fecha Cuenta::fecha() const { return *_fecha; }

void Cuenta::fecha(Fecha f) { *_fecha = f; }

double Cuenta::saldo() const { return _saldo; }

void Cuenta::saldo(double s) { _saldo = s; }

void Cuenta::nuevo(Movimiento* m) {
  _movs->insertar(m);
  _saldo += m->apunte();
}

void Cuenta::mostrar() const {
  cout << endl;
  cout << "Cliente: " << _cliente->nombreCompleto() << " ("
       << _cliente->nif() << "), " << _cliente->edad() << " aos" << endl;
  cout << "Cuenta abierta el " << _fecha->completa() << endl;
  cout << "Saldo actual: " << _saldo << " Eur" << endl;
}

void Cuenta::extracto() const {
  mostrar();
  _movs->mostrar();
}
