// Clase Publicacion - Implementacin "publicacion.cpp"

#include "publicacion.h"

// F.C.O.

Publicacion::Publicacion(string tit, string c, string p, Fecha f)
  : _titulo(tit), _ciudad(c), _pais(p) { _fecha = new Fecha(); *_fecha = f; }

Publicacion::Publicacion(const Publicacion& otro) {
  _titulo = otro._titulo;
  _ciudad = otro._ciudad;
  _pais = otro._pais;
  _fecha = new Fecha();
  *_fecha = *otro._fecha;
}

Publicacion& Publicacion::operator=(const Publicacion& otro) {
  _titulo = otro._titulo;
  _ciudad = otro._ciudad;
  _pais = otro._pais;
  *_fecha = *otro._fecha;
  return *this;
}

Publicacion::~Publicacion() { delete _fecha; }

// Accedentes

string Publicacion::titulo() const { return _titulo; }

string Publicacion::ciudad() const { return _ciudad; }

string Publicacion::pais() const { return _pais; }

Fecha Publicacion::fecha() const { return *_fecha; }

// Mutadores

void Publicacion::titulo(string t) { _titulo = t; }

void Publicacion::ciudad(string c) { _ciudad = c; }

void Publicacion::pais(string p) { _pais = p; }

void Publicacion::fecha(Fecha f) { *_fecha = f; }

// Otros mtodos

void Publicacion::leer() {
  cout << "Titulo: "; getline(cin, _titulo);
  cout << "Lugar de edicion:" << endl;
  cout << "  Ciudad: "; getline(cin, _ciudad);
  cout << "  Pais: "; getline(cin, _pais);
  cin.ignore();
  cout << "Fecha de edicion:" << endl;
  _fecha->leer();
}

void Publicacion::mostrar() const {
  cout << _titulo << " [";
  cout << _ciudad << " (" << _pais << "), " << _fecha->reducida() << "]."<< endl;
}

 