// Clase Volumen - Implementacin "volumen.cpp"
// _autor como atributo relacin

#include "volumen.h"

// F.C.O.

Volumen::Volumen(string tit, string c, string p, Fecha f, Persona* a)
  : Publicacion(tit, c, p, f), _autor(a) { }
  // Las relaciones no se crean

Volumen::Volumen(const Volumen& otro) : Publicacion (otro) {
  // Las relaciones no se crean
  _autor = otro._autor;
  // Relacionado con la misma Persona (misma direccin)
}

Volumen& Volumen::operator=(const Volumen& otro) {
  Publicacion::operator=(otro);
  _autor = otro._autor;
  // Relacionados con la misma Persona (misma direccin)
  return *this;
}

Volumen::~Volumen() { } // Las relaciones no se destruyen

// Accedente

Persona* Volumen::autor() const { return _autor; }
// Devuelve la direccin de la Persona con la que est relacionada

// Mutador

void Volumen::autor(Persona* p) { _autor = p; }
// Se relaciona con la Persona cuya direccin se proporciona

// Otros mtodos

void Volumen::leer() {
  Publicacion::leer();
  // El objeto con el que est relacionado ya existe
  // y ya tiene sus datos ledos.
}

void Volumen::mostrar() const {
  Publicacion::mostrar();
  cout << "Autor: ";
  if(_autor == NULL) cout << "Sin datos. ";
  else cout << _autor->nombreCompleto() << ". ";
  // Se puede usar el objeto con el que se est relacionado
  // siempre y cuando est establecida la relacin
}


 